#ifndef __METAPARTS__H
#define __METAPARTS__H

#define HABSPEED
#define HABSPEED2

#include "max.h"
#include "particle.h"
#define TOPF 0
#define FRONTF 1
#define RIGHTF 2	
#define BACKF 3	
#define LEFTF 4	
#define BOTF 5	
typedef struct{
 Point3 vmin,vmax;
 int pstart,pstop;
}BunchData;
typedef struct{
  int pattern,v[4];
}linedata;
typedef struct
{ float field;
  linedata oldfaces[3];
} corners;
typedef struct{
 Point3 pos;
 int gridnum;
 float field;
 BOOL sign;
}cubepts;
typedef struct { 
int p1,p2,e1a,e1b,e2a,e2b;
}bseg;

class BlobParticle {
	public:
		Tab<BunchData> bloblst;

		Tab<int> plst;
		Tab<Point3> maxpoint;
		Tab<Point3> minpoint;
#ifdef HABSPEED
		float *rsquare;
		float *tensionOverR4;
		Point3 *pospoint;
#else
		Tab<float> rsquare;
#endif
		float tens;

		float fthreshold;
		int bnum,cblob,Nx,Ny,Nz;
		Point3 deltax,deltay,deltaz,deltaxy;
		corners *level0,*level1;
		int vertex,face;
#ifdef HABSPEED2
		int vAlloc,vBlock,vFree;
		int faceAlloc,faceBlock,faceFree;
#endif
		void RecalcBounds(int num,Point3 pvmin,Point3 pvmax);
		BOOL CheckBounds(int num,Point3 pvmin,Point3 pvmax);
		void AddABlob(int c,int *incount);
		BOOL OneInSet(int bnum) {return(bloblst[bnum].pstart==bloblst[bnum].pstop);}
		void AddToSet(int bcount,int going);
		void MergeSet(int bcount);
#ifdef HABSPEED
		void FillInFields(corners *level,int start,int ix,int y,cubepts *cube);
		float CalcField(Point3 cpos);
#else
		void FillInFields(corners *level,int start,int ix,int y,cubepts *cube,Point3 *parts);
		float CalcField(Point3 cpos,Point3 *parts);
#endif
		Point3 CheckForVertex(Point3 apos,Point3 bpos,float afield,float bfield);
		int FindVNum(int edge,linedata oldrec);
		int GetOldVertex(int oldface,int newface,linedata oldrec);
		int CheckCurBlst(bseg *blst,int bcount,int a, int b);
		void AddLine(bseg *blst,int *bcount,int *vlst,int a,int b,int *sign,int *edge);
#ifdef HABSPEED
		void FillInFace(cubepts *cube,bseg *blst,int *bcount,int a,int b,int c, int d,linedata *srec,int *oldv,linedata *olddata,Mesh *mesh);
		void FillInCube(cubepts *cube,bseg *blst,int *bcount,Mesh *mesh);
		void DoCube(int ix,int x,int y,int z,Point3 cpos,Mesh *mesh);
#else
		void FillInFace(cubepts *cube,bseg *blst,int *bcount,int a,int b,int c, int d,linedata *srec,int *oldv,linedata *olddata,Mesh *mesh,Point3 *parts);
		void FillInCube(cubepts *cube,bseg *blst,int *bcount,Mesh *mesh,Point3 *parts);
		void DoCube(int ix,int x,int y,int z,Point3 cpos,Point3 *parts,Mesh *mesh);
#endif
		void GenerateFaces(bseg *line,int lcount,Mesh *mesh);
		int AllocateCubes(int levelmax);
//watje
//		int CreateBlobs(ParticleSys parts,Mesh *mesh,float threshold,float res,float strength, float size);
		int CreateBlobs(Point3 *parts,int count, Mesh *mesh,
			             float threshold,float res,float strength, float size);

//HAB added this
		void AddFace(int a, int b, int c,int face,Mesh *pm,int curmtl);
	};

#endif  // __PARTICLE__
